/*
 USB Camera control via DirectShow
 */

#include <iostream>
#include "DirectShow.h"
#include "ewclib.h"


ds_Camera::ds_Camera(void)
:num(0),id(0),width(CAPTURE_SIZE_X),height(CAPTURE_SIZE_Y),channels(3),depth(8),fps(10)
{
}

ds_Camera::~ds_Camera(void)
{
	return;
}

bool ds_Camera::initialize(void) {
	int n = EWC_Open(0, width, height, fps);
	if(n != 0){
	  std::cerr << "Fail to initialize ds_Camera." << std::endl;
	  return false;
	}
	num = EWC_GetCamera();
	if(num < 1) {
	  std::cerr << num << " cameras found." << std::endl;
	  return false;
	}

	frame = cvCreateImage(cvSize(width, height), depth, channels);
	image_size = width *height *channels;
}

void ds_Camera::finalize(void) {
  EWC_CloseAll();
  cvReleaseImage(&frame);
}

int
ds_Camera::capture(void)
{
    int count = 0;


	while( EWC_IsCaptured(id) == 0){
		//cvWaitKey(3);
		Sleep(10);
		count += 1;
		if(count > 10) return -1;
	}

	EWC_GetImage(id, frame->imageData);

	return 0;
}

int
ds_Camera::getImageSize(void)
{
	return image_size;
}

char *
ds_Camera::getImageData(void)
{
	return frame->imageData;
}

